package Services
{
	/**
	 * @author chenyuming
	 */
	import mx.controls.Alert;
	import mx.managers.CursorManager;
	import mx.rpc.AbstractOperation;
	import mx.rpc.AsyncToken;
	import mx.rpc.IResponder;
	import mx.rpc.Responder;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.soap.SOAPHeader;
	import mx.rpc.soap.WebService;
	
	public class CYMService extends WebService
	{
		//构造函数 @wsdl：WebService地址
		public function CYMService(wsdl:String)
		{
			super();
			
			this.wsdl = wsdl;
			this.loadWSDL();
		}

		
		//调用WebService中的函数 
		public function call(methodName:String,callback:Function,...args):void
		{
			var method:AbstractOperation = this.getOperation(methodName);
			method.arguments = args;
			
			var call:AsyncToken = method.send();
			call.userDefinedCallback = callback;
			call.addResponder(new Responder(resultCallback, faultCallback));
		}
		
		//设置成功时回调函数
		public function resultCallback(event:ResultEvent):void 
		{
			var callback:Function = event.token.userDefinedCallback as Function;
			
			if (callback != null) 
			{
				var result:CYMServiceResult = new CYMServiceResult();
				result.error = false;
				result.result = event.result;
				callback(result);
			}
		}
		
		//设置失败时回调函数
		public function faultCallback(event:FaultEvent):void 
		{
			var callback:Function = event.token.userDefinedCallback as Function;
			if (callback != null) 
			{
				var result:CYMServiceResult = new CYMServiceResult();
				result.error = true;
				result.errorMessage = event.fault.toString();
				callback(result);
			}
		}
	}
}